#<profile4xi profile = "10" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "rebuild_handle4xi.py">
#<abstract4xi abstract = "providing function rebuild_handle4xi"/>
#<refer4xi reference = "reduction.py"/>
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'rebuild_handle4xi' ] 
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # most-common ones
    import traceback         
except:
    pass
try:                 # rare ones
    import socket        
except:
    pass 
       
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from _get_listener4xi import _get_listener4xi

from constant_family4xi import get_default_family4xi
from current_process4xi import get_authkey_current_process4xi

from client4xi import Client4Xi
from print4xi import print4xi
from recv_handle4xi import recv_handle4xi

from time4xi import time4xi
#"
#/>

 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "rebuild_handle4xi" usage = "
#   rebuild_connection:
#       handle = rebuild_handle(reduced_handle)
#"> 
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/> 
# -------------------------------------------------------------------------------------------------
def rebuild_handle4xi(pickled_data):
    '''
    in reduction.py: handle = rebuild_handle(reduced_handle)
    '''
    
    # -----------------------------------------------------------------------------------------    
    # (Step 1/7)
    # -----------------------------------------------------------------------------------------        
    class2print = "rebuild_handle4xi"
    method2print = "rebuild_handle4xi"

    message2print = "{(Step 1/7a) started" + "; rebuild-handle4xi-started: " + str(rebuild_handle4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
        
    message2print = "{(Step 1/7b) passed" + "; pickled-data-passed-to-rebuild-handle4xi: " + str(pickled_data) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
                  
            
    # -----------------------------------------------------------------------------------------    
    # (Step 2/7)
    # -----------------------------------------------------------------------------------------        
    
    address2xi, handle2xi, inherited2xi = pickled_data
    
    message2print = "{(Step 2/7a) set" + "; address2xi-set-by-rebuild-handle4xi to: " + str(address2xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    
    if address2xi is None:
        message2print = "{(Step 2/7b) yielded" + "; address2xi-yielded-by-rebuild-handle4xi: " + str(address2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 

    
    message2print = "{(Step 2/7c) set" + "; handle2xi-set-by-rebuild-handle4xi to: " + str(handle2xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
              
    
    message2print = "{(Step 2/7d) set" + "; inherited2xi-set-by-rebuild-handle4xi to: " + str(inherited2xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
     
    
    if inherited2xi:
    
        message2print = "{(Step 2/7e) returning" + "; handle2xi-returning-by-rebuild-handle4xi: " + str(handle2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
        
          
        
        return handle2xi
    

    
    # -----------------------------------------------------------------------------------------    
    # (Step 3/7)
    # -----------------------------------------------------------------------------------------        
    authkey2xi = get_authkey_current_process4xi()

    message2print = "{(Step 3/7a) set" + "; authkey2xi-set-by-rebuild-handle4xi to: " + str(authkey2xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
        
    message2print = "{(Step 3/7b) passing" + "; address2xi-passing-to-Client4Xi-by-rebuild-handle4xi: " + str(address2xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
        
        
    message2print = "{(Step 3/7c) passing" + "; authkey2xi-passing-to-Client4Xi-by-rebuild-handle4xi: " + str(authkey2xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
           
    try:        
        connection2xi = Client4Xi(address2xi, get_default_family4xi(), authkey2xi)                                     #dragonized
        
        message2print = "{(Step 3/7d) set" + "; connection2xi-set-by-rebuild-handle4xi to: " + str(connection2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
    except:
        message2print = "{(Step 3/7e) yielded" + "; Client4Xi-yielded-by-rebuild-handle4xi: " + str(Client4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
      
    
    # -----------------------------------------------------------------------------------------    
    # (Step 4/7)
    # -----------------------------------------------------------------------------------------        
    message2print = "{(Step 4/7a) passing" + "; handle2xi-passing-to-connection2xi-send-by-rebuild-handle4xi: " + str(handle2xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
        
    message2print = "{(Step 4/7b) passing" + "; os-pid-passing-to-connection2xi-send-by-rebuild-handle4xi: " + str(os.getpid()) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
                
    try:
        connection2xi.send((handle2xi, os.getpid()))
        
        message2print = "{(Step 4/7c) performed" + "; connection2xi-send-performed-by-rebuild-handle4xi: " + str(connection2xi.send) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
    except:
        message2print = "{(Step 4/7d) yielded" + "; send-yielded-by-rebuild-handle4xi: " + str(connection2xi.send)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 

    
    # -----------------------------------------------------------------------------------------    
    # (Step 5/7)
    # -----------------------------------------------------------------------------------------        
    message2print = "{(Step 5/7a) passing" + "; connection2xi-passing-to-recv-handle4xi-by-rebuild-handle4xi: " + str(connection2xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
    
    new_handle2xi = None
        
    try:        
        new_handle2xi = recv_handle4xi(connection2xi)
        
        message2print = "{(Step 5/7b) got" + "; new-handle2xi-got-by-rebuild-handle4xi: " + str(new_handle2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
    except:
        message2print = "{(Step 5/7c) yielded" + "; receiving-yielded-by-rebuild-handle4xi: " + str(recv_handle4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                
              
    
    # -----------------------------------------------------------------------------------------    
    # (Step 6/7)
    # -----------------------------------------------------------------------------------------        
    try:
        connection2xi.close()
        
        message2print = "{(Step 6/7a) performed" + "; connection2xi-close-performed-by-rebuild-handle4xi: " + str(connection2xi.close) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
    except:
        message2print = "{(Step 6/7b) yielded" + "; close-yielded-by-rebuild-handle4xi: " + str(connection2xi.close)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
       
    
    # -----------------------------------------------------------------------------------------    
    # (Step 7/7)
    # -----------------------------------------------------------------------------------------        
    message2print = "{(Step 7/7) returning" + "; new-handle2xi-returning-by-rebuild-handle4xi: " + str(new_handle2xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)   
        

    return new_handle2xi
#</function4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of rebuild_handle4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
